defstar {
	name { Pad}
	derived { C50Chop }
	domain { C50 }
	desc { Fix pad
On each execution, reads a block of "nread" samples (default 128) and writes
a block of "nwrite" samples (default 256).  The first "offset" samples
(default 0) have value "fill" (default 0.0), the next "nread" outputs
samples have values taken from the inputs, and last "nwrite" -
"nread" - "offset" samples have value "fill" again.
	}
	version { @(#)C50Pad.pl	1.3	7/22/96 }
	author { Luis Gutierrez}
	copyright {
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
	}
	location { C50 main library }
	explanation {
The star pads the input with fill values.
An input block of length \fInread\fR is read in.
The first \fIoffset\fR outputs will be zeros,
then the next \fInread\fR outputs will be the inputs
that are read in, and any remaining outputs will be zeros.
To ensure correct operation,
\fInread\fR + \fIoffset\fR must be smaller than \fInwrite\fR.
}
        seealso { Chop }


	constructor {
        //first change type of ports in Chop 'cause they're ANYTYPE
	
	input.setResolvedType(FIX);
	output.setResolvedType(FIX);

	// now do states

	fill.setAttributes(A_SETTABLE);
	use_past_inputs.clearAttributes(A_SETTABLE);
	use_past_inputs.setInitValue("NO");
	pastInputs.clearAttributes(A_UMEM);
	pastInputsPtr.clearAttributes(A_UMEM);
	}

	//dummy initCode method to avoid using initCode
	//method in Chop

	initCode{}

	// Since this star is just like the Chop star
	// inherit everything else from C50Chop
}















